package com.elasticjee.api.enterprise;

import javax.persistence.*;
import java.io.Serializable;
import java.util.Date;

/**
 * @author yangck
 */
@Entity
@Table(name = "sec$enterprises")
//@Cacheable
//@Cache(usage = CacheConcurrencyStrategy.READ_WRITE, region = "com.uas.platform.b2c.model.Enterprise")
public class Enterprise implements Serializable {

    /**
     * 序列号
     */
    private static final long serialVersionUID = 1L;

    @Id
    @Column(name = "en_uu")
    private Long uu;

    /**
     * 公司名称
     */
    @Column(name = "en_name")
    private String enName;
    /**
     * 简称
     */
    @Column(name = "en_shortname")
    private String enShortname;
    /**
     * 公司类型
     */
    @Column(name = "en_type")
    private String enType;
    /**
     * 企业注册地区
     */
    @Column(name = "en_area")
    private String enArea;
    /**
     * 状态
     */
    @Column(name = "en_status")
    private Short enStatus;
    /**
     * 注册地址
     */
    @Column(name = "en_address")
    private String enAddress;
    /**
     * 默认送货地址
     */
    @Column(name = "en_deliveraddr")
    private String enDeliverAddr;
    /**
     * 公司电话
     */
    @Column(name = "en_tel")
    private String enTel;
    /**
     * 传真
     */
    @Column(name = "en_fax")
    private String enFax;
    /**
     * 公司邮箱
     */
    @Column(name = "en_email")
    private String enEmail;
    /**
     * 公司法人
     */
    @Column(name = "en_corporation")
    private String enCorporation;
    /**
     * 商业登记证号
     */
    @Column(name = "en_businesscode")
    private String enBussinessCode;
    /**
     * 公司主页地址
     */
    @Column(name = "en_url")
    private String enUrl;
    /**
     * 注册时间
     */
    @Column(name = "en_time")
    private Date enDate;

    /**
     * 管理员UU号
     */
    @Column(name = "en_adminuu")
    private Long enAdminuu;

    /**
     * 所属行业
     */
    @Column(name = "en_industry")
    private String enIndustry;

    /**
     * saas域名
     */
    @Column(name = "en_saasurl")
    private String enSaasUrl;

    /**
     * SAAS状态
     */
    @Column(name = "en_saasstatus")
    private Short enSaasStatus;

    /**
     * enIsErp
     */
    @Column(name = "en_iserp")
    private Short enIsErp;

    /**
     * 私钥
     */
    @Column(name = "en_accesssecret")
    private String accessSecret;

    @Transient
    private Integer receiptStatus;

    /**
     * saas用户
     *
     * @return
     */
    public boolean isSaas() {
        return this.enSaasStatus != null && EnterpriseStatus.ENABLED.value() == this.enSaasStatus;
    }

    @Override
    public int hashCode() {
        final int prime = 31;
        int result = 1;
        result = prime * result + ((uu == null) ? 0 : uu.hashCode());
        return result;
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj)
            return true;
        if (obj == null)
            return false;
        if (getClass() != obj.getClass())
            return false;
        Enterprise other = (Enterprise) obj;
        if (uu == null) {
            if (other.uu != null)
                return false;
        } else if (!uu.equals(other.uu))
            return false;
        return true;
    }

    public Long getUu() {
        return uu;
    }

    public void setUu(Long uu) {
        this.uu = uu;
    }

    public String getEnName() {
        return enName;
    }

    public void setEnName(String enName) {
        this.enName = enName;
    }

    public String getEnShortname() {
        return enShortname;
    }

    public void setEnShortname(String enShortname) {
        this.enShortname = enShortname;
    }

    public String getEnType() {
        return enType;
    }

    public void setEnType(String enType) {
        this.enType = enType;
    }

    public String getEnArea() {
        return enArea;
    }

    public void setEnArea(String enArea) {
        this.enArea = enArea;
    }

    public Short getEnStatus() {
        return enStatus;
    }

    public void setEnStatus(Short enStatus) {
        this.enStatus = enStatus;
    }

    public String getEnAddress() {
        return enAddress;
    }

    public void setEnAddress(String enAddress) {
        this.enAddress = enAddress;
    }

    public String getEnDeliverAddr() {
        return enDeliverAddr;
    }

    public void setEnDeliverAddr(String enDeliverAddr) {
        this.enDeliverAddr = enDeliverAddr;
    }

    public String getEnTel() {
        return enTel;
    }

    public void setEnTel(String enTel) {
        this.enTel = enTel;
    }

    public String getEnFax() {
        return enFax;
    }

    public void setEnFax(String enFax) {
        this.enFax = enFax;
    }

    public String getEnEmail() {
        return enEmail;
    }

    public void setEnEmail(String enEmail) {
        this.enEmail = enEmail;
    }

    public String getEnCorporation() {
        return enCorporation;
    }

    public void setEnCorporation(String enCorporation) {
        this.enCorporation = enCorporation;
    }

    public String getEnBussinessCode() {
        return enBussinessCode;
    }

    public void setEnBussinessCode(String enBussinessCode) {
        this.enBussinessCode = enBussinessCode;
    }

    public String getEnUrl() {
        return enUrl;
    }

    public void setEnUrl(String enUrl) {
        this.enUrl = enUrl;
    }

    public Date getEnDate() {
        return enDate;
    }

    public void setEnDate(Date enDate) {
        this.enDate = enDate;
    }

    public Long getEnAdminuu() {
        return enAdminuu;
    }

    public void setEnAdminuu(Long enAdminuu) {
        this.enAdminuu = enAdminuu;
    }

    public String getEnIndustry() {
        return enIndustry;
    }

    public void setEnIndustry(String enIndustry) {
        this.enIndustry = enIndustry;
    }

    public String getEnSaasUrl() {
        return enSaasUrl;
    }

    public void setEnSaasUrl(String enSaasUrl) {
        this.enSaasUrl = enSaasUrl;
    }

    public Short getEnSaasStatus() {
        return enSaasStatus;
    }

    public void setEnSaasStatus(Short enSaasStatus) {
        this.enSaasStatus = enSaasStatus;
    }

    public Short getEnIsErp() {
        return enIsErp;
    }

    public void setEnIsErp(Short enIsErp) {
        this.enIsErp = enIsErp;
    }

    public String getAccessSecret() {
        return accessSecret;
    }

    public void setAccessSecret(String accessSecret) {
        this.accessSecret = accessSecret;
    }

    public Integer getReceiptStatus() {
        return receiptStatus;
    }

    public void setReceiptStatus(Integer receiptStatus) {
        this.receiptStatus = receiptStatus;
    }
}
