package com.elasticjee.api.enterprise;

import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.query.Param;

import java.util.List;

/**
 * @author yangck
 */
public interface EnterpriseRepository extends JpaRepository<Enterprise, Long> {

    Enterprise findByEnuu(Long enUu);

    @Query("from Enterprise e where e.uu in (:enUus)")
    List<Enterprise> findByEnUus(@Param("enUus") List<Long> enUus);

    @Query(value="select e.uu from Enterprise e where e.enName like %?1%")
    List<Long> findEnUusByName(String name);

}
