package com.elasticjee.api.v1;

import com.elasticjee.user.User;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.security.core.userdetails.UsernameNotFoundException;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import javax.servlet.http.HttpSession;
import java.security.Principal;
import java.util.Optional;

/**
 * @author yangck
 */
@RestController
@RequestMapping("/v1")
public class UserControllerV1 {

    @Autowired
    private UserServiceV1 userService;

    @RequestMapping(path = "/me")
    public ResponseEntity<User> me(Principal principal, HttpSession httpSession) {
        User user = null;
        if(principal != null) {
            //user = userService.getUserByUsername(principal.getName());
            user = (User) httpSession.getAttribute("user");
        }
        return Optional.ofNullable(user)
                .map(a -> new ResponseEntity<>(a, HttpStatus.OK))
                .orElseThrow(() -> new UsernameNotFoundException("Username not found"));
    }

    /**
     * 选择企业
     * @param enUU
     * @param httpSession
     * @return
     */
    @RequestMapping(value = "/selectEnterprise", method = RequestMethod.POST)
    public String selectEnterprise(@RequestParam("enUU") Long enUU, HttpSession httpSession) {
        httpSession.setAttribute("enUU", enUU);
        User user = (User) httpSession.getAttribute("user");
        user.setCurrentEnterprise(enUU);
        return "success";
    }

}