package com.elasticjee.util.encrypt;

import org.apache.log4j.LogManager;
import org.apache.log4j.Logger;

import java.io.UnsupportedEncodingException;
import java.security.MessageDigest;
import java.security.NoSuchAlgorithmException;

/**
 * Md5加密
 * @author yangck
 */
public class Md5Encrypt {

    private final Logger logger = LogManager.getLogger(Md5Encrypt.class);

    private static final Md5Encrypt singleton = new Md5Encrypt();

    private Md5Encrypt() {}

    public static Md5Encrypt getSingleton() {
        return singleton;
    }

    /**
     * @Description 字符串加密为MD5 中文加密一致通用,必须转码处理： plainText.getBytes("UTF-8")
     * @param plainText
     *            需要加密的字符串
     * @return
     */
    public String encrypt(String plainText) {

        // 超过32认为是已加密过的密文
        if (plainText.length() >= 32) {
            logger.error(String.format("传递过来的密码(%s)必须是未加密的明文", plainText));
            throw new IllegalArgumentException("invalid password");
        }

        String result = "";
        try {
            result = md5String(plainText.getBytes("UTF-8"));
        } catch (UnsupportedEncodingException e) {
            logger.error("UTF-8编码不支持");
            e.printStackTrace();
        }
        return result;
    }

    public String md5String(byte[] data) {
        String md5Str = "";
        try {
            MessageDigest md5 = MessageDigest.getInstance("MD5");
            byte[] buf = md5.digest(data);
            for (int i = 0; i < buf.length; i++) {
                md5Str += Byte2Hex.byte2Hex(buf[i]);
            }
        } catch (NoSuchAlgorithmException e) {
            md5Str = null;
            logger.error("不支持MD5算法");
            e.printStackTrace();
        }
        return md5Str;
    }

}

